<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.14" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="cyhal__rtc_8c" kind="file" language="C++">
    <compoundname>cyhal_rtc.c</compoundname>
    <includes local="yes">cy_rtc.h</includes>
    <includes local="yes">cy_utils.h</includes>
    <includes local="yes" refid="cyhal__rtc_8h">cyhal_rtc.h</includes>
    <includes local="yes" refid="cyhal__system_8h">cyhal_system.h</includes>
    <incdepgraph>
      <node id="330">
        <label>cy_rtc.h</label>
      </node>
      <node id="329">
        <label>cyhal_rtc.c</label>
        <link refid="cyhal__rtc_8c" />
        <childnode refid="330" relation="include">
        </childnode>
        <childnode refid="331" relation="include">
        </childnode>
      </node>
      <node id="331">
        <label>cy_utils.h</label>
      </node>
    </incdepgraph>
    <briefdescription>
<para>Provides a high level interface for interacting with the Cypress Real-Time Clock. </para>    </briefdescription>
    <detaileddescription>
<para>This interface abstracts out the chip specific details. If any chip specific functionality is necessary, or performance is critical the low level functions can be used directly.</para><para><simplesect kind="copyright"><para>Copyright 2018-2020 Cypress Semiconductor Corporation SPDX-License-Identifier: Apache-2.0</para></simplesect>
Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at <verbatim>http://www.apache.org/licenses/LICENSE-2.0
</verbatim></para><para>Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License. </para>    </detaileddescription>
    <programlisting>
<codeline lineno="1"><highlight class="comment">/***************************************************************************/</highlight></codeline>
<codeline lineno="28"><highlight class="preprocessor">#include<sp />"cy_rtc.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="29"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cy_utils.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="30"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_rtc.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="31"><highlight class="normal" /><highlight class="preprocessor">#include<sp />"cyhal_system.h"</highlight><highlight class="normal" /></codeline>
<codeline lineno="32"><highlight class="normal" /></codeline>
<codeline lineno="52"><highlight class="preprocessor">#ifdef<sp />CY_IP_MXS40SRSS_RTC_INSTANCES</highlight><highlight class="normal" /></codeline>
<codeline lineno="53"><highlight class="normal" /></codeline>
<codeline lineno="54"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="55"><highlight class="normal" /><highlight class="keyword">extern</highlight><highlight class="normal"><sp /></highlight><highlight class="stringliteral">"C"</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="56"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="57"><highlight class="normal" /></codeline>
<codeline lineno="58"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_STATE_UNINITIALIZED<sp />0</highlight><highlight class="normal" /></codeline>
<codeline lineno="59"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_STATE_ENABLED<sp />1</highlight><highlight class="normal" /></codeline>
<codeline lineno="60"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_STATE_TIME_SET<sp />2</highlight><highlight class="normal" /></codeline>
<codeline lineno="61"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_DEFAULT_PRIORITY<sp />5</highlight><highlight class="normal" /></codeline>
<codeline lineno="62"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_INIT_CENTURY<sp />2000</highlight><highlight class="normal" /></codeline>
<codeline lineno="63"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_TM_YEAR_BASE<sp />1900</highlight><highlight class="normal" /></codeline>
<codeline lineno="64"><highlight class="normal" /></codeline>
<codeline lineno="65"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_BREG<sp />(BACKUP-&gt;BREG[SRSS_BACKUP_NUM_BREG-1])</highlight><highlight class="normal" /></codeline>
<codeline lineno="66"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_BREG_CENTURY_Pos<sp />0UL</highlight><highlight class="normal" /></codeline>
<codeline lineno="67"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_BREG_CENTURY_Msk<sp />0x0000FFFFUL</highlight><highlight class="normal" /></codeline>
<codeline lineno="68"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_BREG_STATE_Pos<sp />16UL</highlight><highlight class="normal" /></codeline>
<codeline lineno="69"><highlight class="normal" /><highlight class="preprocessor">#define<sp />_CYHAL_RTC_BREG_STATE_Msk<sp />0xFFFF0000UL</highlight><highlight class="normal" /></codeline>
<codeline lineno="70"><highlight class="normal" /></codeline>
<codeline lineno="72"><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_en_syspm_status_t<sp />_cyhal_rtc_syspm_callback(cy_stc_syspm_callback_params_t<sp />*params,<sp />cy_en_syspm_callback_mode_t<sp />mode)</highlight></codeline>
<codeline lineno="73"><highlight class="normal">{</highlight></codeline>
<codeline lineno="74"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />Cy_RTC_DeepSleepCallback(params,<sp />mode);</highlight></codeline>
<codeline lineno="75"><highlight class="normal">}</highlight></codeline>
<codeline lineno="76"><highlight class="normal" /></codeline>
<codeline lineno="77"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_stc_rtc_dst_t<sp />*_cyhal_rtc_dst;</highlight></codeline>
<codeline lineno="78"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp />cy_stc_syspm_callback_params_t<sp />_cyhal_rtc_pm_cb_params<sp />=<sp />{NULL,<sp />NULL};</highlight></codeline>
<codeline lineno="79"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__types__implementation_1gabb967889ff74acdaad515b63d1761752">cy_stc_syspm_callback_t</ref><sp />_cyhal_rtc_pm_cb<sp />=<sp />{</highlight></codeline>
<codeline lineno="80"><highlight class="normal"><sp /><sp /><sp /><sp />.callback<sp />=<sp />&amp;_cyhal_rtc_syspm_callback,</highlight></codeline>
<codeline lineno="81"><highlight class="normal"><sp /><sp /><sp /><sp />.type<sp />=<sp />CY_SYSPM_DEEPSLEEP,</highlight></codeline>
<codeline lineno="82"><highlight class="normal"><sp /><sp /><sp /><sp />.callbackParams<sp />=<sp />&amp;_cyhal_rtc_pm_cb_params,</highlight></codeline>
<codeline lineno="83"><highlight class="normal">};</highlight></codeline>
<codeline lineno="84"><highlight class="normal" /></codeline>
<codeline lineno="85"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga2fe62b8562ac40925a243c75b0e6810f">cyhal_rtc_event_callback_t</ref><sp />_cyhal_rtc_user_handler;</highlight></codeline>
<codeline lineno="86"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*_cyhal_rtc_handler_arg;</highlight></codeline>
<codeline lineno="87"><highlight class="normal" /></codeline>
<codeline lineno="88"><highlight class="normal" /><highlight class="comment">/*<sp />Returns<sp />century<sp />portion<sp />of<sp />BREG<sp />register<sp />used<sp />to<sp />store<sp />century<sp />info<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="89"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">inline</highlight><highlight class="normal"><sp />uint16_t<sp />_cyhal_rtc_get_century(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="90"><highlight class="normal">{</highlight></codeline>
<codeline lineno="91"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />_FLD2VAL(_CYHAL_RTC_BREG_CENTURY,<sp />_CYHAL_RTC_BREG);</highlight></codeline>
<codeline lineno="92"><highlight class="normal">}</highlight></codeline>
<codeline lineno="93"><highlight class="normal" /></codeline>
<codeline lineno="94"><highlight class="normal" /><highlight class="comment">/*<sp />Sets<sp />century<sp />portion<sp />of<sp />BREG<sp />register<sp />used<sp />to<sp />store<sp />century<sp />info<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="95"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">inline</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />_cyhal_rtc_set_century(uint16_t<sp />century)</highlight></codeline>
<codeline lineno="96"><highlight class="normal">{</highlight></codeline>
<codeline lineno="97"><highlight class="normal"><sp /><sp /><sp /><sp />_CYHAL_RTC_BREG<sp />&amp;=<sp />_CYHAL_RTC_BREG_STATE_Msk;</highlight></codeline>
<codeline lineno="98"><highlight class="normal"><sp /><sp /><sp /><sp />_CYHAL_RTC_BREG<sp />|=<sp />_VAL2FLD(_CYHAL_RTC_BREG_CENTURY,<sp />century);</highlight></codeline>
<codeline lineno="99"><highlight class="normal">}</highlight></codeline>
<codeline lineno="100"><highlight class="normal" /></codeline>
<codeline lineno="101"><highlight class="normal" /><highlight class="comment">/*<sp />Returns<sp />state<sp />portion<sp />of<sp />BREG<sp />register<sp />used<sp />to<sp />store<sp />century<sp />info<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="102"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">inline</highlight><highlight class="normal"><sp />uint16_t<sp />_cyhal_rtc_get_state(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="103"><highlight class="normal">{</highlight></codeline>
<codeline lineno="104"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />_FLD2VAL(_CYHAL_RTC_BREG_STATE,<sp />_CYHAL_RTC_BREG);</highlight></codeline>
<codeline lineno="105"><highlight class="normal">}</highlight></codeline>
<codeline lineno="106"><highlight class="normal" /></codeline>
<codeline lineno="107"><highlight class="normal" /><highlight class="comment">/*<sp />Sets<sp />state<sp />portion<sp />of<sp />BREG<sp />register<sp />used<sp />to<sp />store<sp />century<sp />info<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="108"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">inline</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />_cyhal_rtc_set_state(uint16_t<sp />init)</highlight></codeline>
<codeline lineno="109"><highlight class="normal">{</highlight></codeline>
<codeline lineno="110"><highlight class="normal"><sp /><sp /><sp /><sp />_CYHAL_RTC_BREG<sp />&amp;=<sp />_CYHAL_RTC_BREG_CENTURY_Msk;</highlight></codeline>
<codeline lineno="111"><highlight class="normal"><sp /><sp /><sp /><sp />_CYHAL_RTC_BREG<sp />|=<sp />_VAL2FLD(_CYHAL_RTC_BREG_STATE,<sp />init);</highlight></codeline>
<codeline lineno="112"><highlight class="normal">}</highlight></codeline>
<codeline lineno="113"><highlight class="normal" /></codeline>
<codeline lineno="114"><highlight class="normal" /><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />_cyhal_rtc_initialize_dst(</highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__rtc__dst__t">cyhal_rtc_dst_t</ref><sp />*hal,<sp />cy_stc_rtc_dst_format_t<sp />*pdl)</highlight></codeline>
<codeline lineno="115"><highlight class="normal">{</highlight></codeline>
<codeline lineno="116"><highlight class="normal"><sp /><sp /><sp /><sp />pdl-&gt;format<sp />=<sp />(hal-&gt;<ref kindref="member" refid="structcyhal__rtc__dst__t_1a1811ad3e83ce0a73c208b42a42d33693">format</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__rtc_1gga70f0bde8db19e6aacbbd72afc1fa3f9fabf285ab71718312d1764612ac46c78d1">CYHAL_RTC_DST_FIXED</ref>)<sp />?<sp />CY_RTC_DST_FIXED<sp />:<sp />CY_RTC_DST_RELATIVE;</highlight></codeline>
<codeline lineno="117"><highlight class="normal"><sp /><sp /><sp /><sp />pdl-&gt;hour<sp />=<sp />hal-&gt;<ref kindref="member" refid="structcyhal__rtc__dst__t_1a5270b5844693af6788a0a5da60ead51c">hour</ref>;</highlight></codeline>
<codeline lineno="118"><highlight class="normal"><sp /><sp /><sp /><sp />pdl-&gt;dayOfMonth<sp />=<sp />(hal-&gt;<ref kindref="member" refid="structcyhal__rtc__dst__t_1a1811ad3e83ce0a73c208b42a42d33693">format</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__rtc_1gga70f0bde8db19e6aacbbd72afc1fa3f9fabf285ab71718312d1764612ac46c78d1">CYHAL_RTC_DST_FIXED</ref>)<sp />?<sp />hal-&gt;dayOfMonth<sp />:<sp />1;</highlight></codeline>
<codeline lineno="119"><highlight class="normal"><sp /><sp /><sp /><sp />pdl-&gt;weekOfMonth<sp />=<sp />(hal-&gt;<ref kindref="member" refid="structcyhal__rtc__dst__t_1a1811ad3e83ce0a73c208b42a42d33693">format</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__rtc_1gga70f0bde8db19e6aacbbd72afc1fa3f9fabf285ab71718312d1764612ac46c78d1">CYHAL_RTC_DST_FIXED</ref>)<sp />?<sp />1<sp />:<sp />hal-&gt;weekOfMonth<sp />+<sp />1;</highlight></codeline>
<codeline lineno="120"><highlight class="normal"><sp /><sp /><sp /><sp />pdl-&gt;dayOfWeek<sp />=<sp />(hal-&gt;<ref kindref="member" refid="structcyhal__rtc__dst__t_1a1811ad3e83ce0a73c208b42a42d33693">format</ref><sp />==<sp /><ref kindref="member" refid="group__group__hal__rtc_1gga70f0bde8db19e6aacbbd72afc1fa3f9fabf285ab71718312d1764612ac46c78d1">CYHAL_RTC_DST_FIXED</ref>)<sp />?<sp />1<sp />:<sp />hal-&gt;dayOfWeek<sp />+<sp />1;</highlight></codeline>
<codeline lineno="121"><highlight class="normal"><sp /><sp /><sp /><sp />pdl-&gt;<ref kindref="member" refid="structcyhal__rtc__dst__t_1a7063f23fa8e30374c3c6593d272dc99f">month</ref><sp />=<sp />hal-&gt;<ref kindref="member" refid="structcyhal__rtc__dst__t_1a7063f23fa8e30374c3c6593d272dc99f">month</ref>;</highlight></codeline>
<codeline lineno="122"><highlight class="normal">}</highlight></codeline>
<codeline lineno="123"><highlight class="normal" /></codeline>
<codeline lineno="125"><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />_cyhal_rtc_isr_handler(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="126"><highlight class="normal">{</highlight></codeline>
<codeline lineno="127"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_Interrupt(_cyhal_rtc_dst,<sp />NULL<sp />!=<sp />_cyhal_rtc_dst);</highlight></codeline>
<codeline lineno="128"><highlight class="normal">}</highlight></codeline>
<codeline lineno="129"><highlight class="normal" /></codeline>
<codeline lineno="130"><highlight class="normal" /><highlight class="comment">/*<sp />Override<sp />weak<sp />function<sp />from<sp />PDL<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline lineno="131"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_RTC_Alarm1Interrupt(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="132"><highlight class="normal">{</highlight></codeline>
<codeline lineno="133"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(NULL<sp />!=<sp />_cyhal_rtc_user_handler)</highlight></codeline>
<codeline lineno="134"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="135"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(*_cyhal_rtc_user_handler)(_cyhal_rtc_handler_arg,<sp /><ref kindref="member" refid="group__group__hal__rtc_1gga65837a686b1fab2e3b11e0d3ba1fdafea2bf87c0718ced4a1e2528575068bcc37">CYHAL_RTC_ALARM</ref>);</highlight></codeline>
<codeline lineno="136"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="137"><highlight class="normal">}</highlight></codeline>
<codeline lineno="138"><highlight class="normal" /></codeline>
<codeline lineno="139"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />Cy_RTC_CenturyInterrupt(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline lineno="140"><highlight class="normal">{</highlight></codeline>
<codeline lineno="141"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_rtc_set_century(_cyhal_rtc_get_century()<sp />+<sp />100);</highlight></codeline>
<codeline lineno="142"><highlight class="normal">}</highlight></codeline>
<codeline lineno="143"><highlight class="normal" /></codeline>
<codeline lineno="144"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga913818691e0a742dea9172d1dc255f5b">cyhal_rtc_init</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="145"><highlight class="normal">{</highlight></codeline>
<codeline lineno="146"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="147"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="148"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="149"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(_cyhal_rtc_get_state()<sp />==<sp />_CYHAL_RTC_STATE_UNINITIALIZED)</highlight></codeline>
<codeline lineno="150"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="151"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(Cy_RTC_IsExternalResetOccurred())</highlight></codeline>
<codeline lineno="152"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="153"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Reset<sp />to<sp />default<sp />time</highlight><highlight class="normal" /></codeline>
<codeline lineno="154"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_rtc_config_t<sp />defaultTime<sp />=<sp />{</highlight></codeline>
<codeline lineno="155"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dayOfWeek<sp />=<sp />CY_RTC_SATURDAY,</highlight></codeline>
<codeline lineno="156"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.date<sp />=<sp />1,</highlight></codeline>
<codeline lineno="157"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.month<sp />=<sp />1,</highlight></codeline>
<codeline lineno="158"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.year<sp />=<sp />0,</highlight></codeline>
<codeline lineno="159"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="160"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_RTC_SetDateAndTime(&amp;defaultTime);</highlight></codeline>
<codeline lineno="161"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_rtc_set_century(_CYHAL_RTC_INIT_CENTURY);</highlight></codeline>
<codeline lineno="162"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="163"><highlight class="normal" /></codeline>
<codeline lineno="164"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(Cy_SysPm_RegisterCallback(&amp;_cyhal_rtc_pm_cb))</highlight></codeline>
<codeline lineno="165"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="166"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_rtc_set_state(_CYHAL_RTC_STATE_ENABLED);</highlight></codeline>
<codeline lineno="167"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="168"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal" /></codeline>
<codeline lineno="169"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="170"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />rslt<sp />=<sp /><ref kindref="member" refid="group__group__hal__results__rtc_1gaae3e49201de8355a8b8f9bcfd88a2d0b">CY_RSLT_RTC_NOT_INITIALIZED</ref>;</highlight></codeline>
<codeline lineno="171"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="172"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="173"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">else</highlight><highlight class="normal"><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(_cyhal_rtc_get_state()<sp />==<sp />_CYHAL_RTC_STATE_ENABLED<sp />||<sp />_cyhal_rtc_get_state()<sp />==<sp />_CYHAL_RTC_STATE_TIME_SET)</highlight></codeline>
<codeline lineno="174"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="175"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(Cy_RTC_GetInterruptStatus()<sp />&amp;<sp />CY_RTC_INTR_CENTURY)</highlight></codeline>
<codeline lineno="176"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_RTC_CenturyInterrupt();</highlight></codeline>
<codeline lineno="177"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="178"><highlight class="normal" /></codeline>
<codeline lineno="179"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_ClearInterrupt(CY_RTC_INTR_CENTURY);</highlight></codeline>
<codeline lineno="180"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_SetInterruptMask(CY_RTC_INTR_CENTURY);</highlight></codeline>
<codeline lineno="181"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />cy_stc_sysint_t<sp />irqCfg<sp />=<sp />{.intrSrc<sp />=<sp />srss_interrupt_backup_IRQn,<sp />.intrPriority<sp />=<sp />_CYHAL_RTC_DEFAULT_PRIORITY};</highlight></codeline>
<codeline lineno="182"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_SysInt_Init(&amp;irqCfg,<sp />&amp;_cyhal_rtc_isr_handler);</highlight></codeline>
<codeline lineno="183"><highlight class="normal" /></codeline>
<codeline lineno="184"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(rslt<sp />==<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>)</highlight></codeline>
<codeline lineno="185"><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline lineno="186"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_rtc_dst<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="187"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NVIC_EnableIRQ(srss_interrupt_backup_IRQn);</highlight></codeline>
<codeline lineno="188"><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline lineno="189"><highlight class="normal" /></codeline>
<codeline lineno="190"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />rslt;</highlight></codeline>
<codeline lineno="191"><highlight class="normal">}</highlight></codeline>
<codeline lineno="192"><highlight class="normal" /></codeline>
<codeline lineno="193"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga4e9f272f48fcf83b09db4603c76b1d79">cyhal_rtc_free</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="194"><highlight class="normal">{</highlight></codeline>
<codeline lineno="195"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="196"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="197"><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_DisableIRQ(srss_interrupt_backup_IRQn);</highlight></codeline>
<codeline lineno="198"><highlight class="normal" /></codeline>
<codeline lineno="199"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_SetInterruptMask(CY_RTC_INTR_CENTURY);</highlight></codeline>
<codeline lineno="200"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_rtc_dst<sp />=<sp />NULL;</highlight></codeline>
<codeline lineno="201"><highlight class="normal">}</highlight></codeline>
<codeline lineno="202"><highlight class="normal" /></codeline>
<codeline lineno="203"><highlight class="normal" /><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__rtc_1gac6891d0e8b9de6c32f46f179aa32b800">cyhal_rtc_is_enabled</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="204"><highlight class="normal">{</highlight></codeline>
<codeline lineno="205"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="206"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="207"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(_cyhal_rtc_get_state()<sp />==<sp />_CYHAL_RTC_STATE_TIME_SET);</highlight></codeline>
<codeline lineno="208"><highlight class="normal">}</highlight></codeline>
<codeline lineno="209"><highlight class="normal" /></codeline>
<codeline lineno="210"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga5c3f15f870f2ecfb4a8a03a58d1eaa5f">cyhal_rtc_read</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp />tm<sp />*time)</highlight></codeline>
<codeline lineno="211"><highlight class="normal">{</highlight></codeline>
<codeline lineno="212"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="213"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="214"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />The<sp />number<sp />of<sp />days<sp />that<sp />precede<sp />each<sp />month<sp />of<sp />the<sp />year,<sp />not<sp />including<sp />Feb<sp />29</highlight><highlight class="normal" /></codeline>
<codeline lineno="215"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint16_t<sp />CUMULATIVE_DAYS[]<sp />=<sp />{0,<sp />31,<sp />59,<sp />90,<sp />120,<sp />151,<sp />181,<sp />212,<sp />243,<sp />273,<sp />304,<sp />334};</highlight></codeline>
<codeline lineno="216"><highlight class="normal" /></codeline>
<codeline lineno="217"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_rtc_config_t<sp />dateTime;</highlight></codeline>
<codeline lineno="218"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />savedIntrStatus<sp />=<sp /><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref>();</highlight></codeline>
<codeline lineno="219"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_GetDateAndTime(&amp;dateTime);</highlight></codeline>
<codeline lineno="220"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">int</highlight><highlight class="normal"><sp />year<sp />=<sp />(int)(dateTime.year<sp />+<sp />_cyhal_rtc_get_century());</highlight></codeline>
<codeline lineno="221"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref>(savedIntrStatus);</highlight></codeline>
<codeline lineno="222"><highlight class="normal" /></codeline>
<codeline lineno="223"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_sec<sp />=<sp />(int)dateTime.sec;</highlight></codeline>
<codeline lineno="224"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_min<sp />=<sp />(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal">)dateTime.min;</highlight></codeline>
<codeline lineno="225"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_hour<sp />=<sp />(int)dateTime.hour;</highlight></codeline>
<codeline lineno="226"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_mday<sp />=<sp />(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal">)dateTime.date;</highlight></codeline>
<codeline lineno="227"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_mon<sp />=<sp />(int)(dateTime.month<sp />-<sp />1u);</highlight></codeline>
<codeline lineno="228"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_year<sp />=<sp />(int)(year<sp />-<sp />_CYHAL_RTC_TM_YEAR_BASE);</highlight></codeline>
<codeline lineno="229"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_wday<sp />=<sp />(int)(dateTime.dayOfWeek<sp />-<sp />1u);</highlight></codeline>
<codeline lineno="230"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_yday<sp />=<sp />(int)CUMULATIVE_DAYS[time-&gt;tm_mon]<sp />+<sp />(</highlight><highlight class="keywordtype">int</highlight><highlight class="normal">)dateTime.date<sp />-<sp />1<sp />+</highlight></codeline>
<codeline lineno="231"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(((int)(dateTime.month)<sp />&gt;=<sp />3<sp />&amp;&amp;<sp />(int)(Cy_RTC_IsLeapYear((uint32_t)year)<sp />?<sp />1u<sp />:<sp />0u)));</highlight></codeline>
<codeline lineno="232"><highlight class="normal"><sp /><sp /><sp /><sp />time-&gt;tm_isdst<sp />=<sp />-1;</highlight></codeline>
<codeline lineno="233"><highlight class="normal" /></codeline>
<codeline lineno="234"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>;</highlight></codeline>
<codeline lineno="235"><highlight class="normal">}</highlight></codeline>
<codeline lineno="236"><highlight class="normal" /></codeline>
<codeline lineno="237"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga09180594a84d768f17d80e1262dce2b7">cyhal_rtc_write</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp />tm<sp />*time)</highlight></codeline>
<codeline lineno="238"><highlight class="normal">{</highlight></codeline>
<codeline lineno="239"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="240"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="241"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />year2digit<sp />=<sp />time-&gt;tm_year<sp />%<sp />100;</highlight></codeline>
<codeline lineno="242"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_rtc_config_t<sp />newtime<sp />=<sp />{</highlight></codeline>
<codeline lineno="243"><highlight class="normal"><sp /><sp /><sp /><sp />.sec<sp />=<sp />(uint32_t)time-&gt;tm_sec,</highlight></codeline>
<codeline lineno="244"><highlight class="normal"><sp /><sp /><sp /><sp />.min<sp />=<sp />(uint32_t)time-&gt;tm_min,</highlight></codeline>
<codeline lineno="245"><highlight class="normal"><sp /><sp /><sp /><sp />.hour<sp />=<sp />(uint32_t)time-&gt;tm_hour,</highlight></codeline>
<codeline lineno="246"><highlight class="normal"><sp /><sp /><sp /><sp />.hrFormat<sp />=<sp />CY_RTC_24_HOURS,</highlight></codeline>
<codeline lineno="247"><highlight class="normal"><sp /><sp /><sp /><sp />.dayOfWeek<sp />=<sp />(uint32_t)time-&gt;tm_wday<sp />+<sp />1,</highlight></codeline>
<codeline lineno="248"><highlight class="normal"><sp /><sp /><sp /><sp />.date<sp />=<sp />(uint32_t)time-&gt;tm_mday,</highlight></codeline>
<codeline lineno="249"><highlight class="normal"><sp /><sp /><sp /><sp />.month<sp />=<sp />(uint32_t)(time-&gt;tm_mon<sp />+<sp />1),</highlight></codeline>
<codeline lineno="250"><highlight class="normal"><sp /><sp /><sp /><sp />.year<sp />=<sp />year2digit</highlight></codeline>
<codeline lineno="251"><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="252"><highlight class="normal" /></codeline>
<codeline lineno="253"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt;</highlight></codeline>
<codeline lineno="254"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />retry<sp />=<sp />0;</highlight></codeline>
<codeline lineno="255"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />MAX_RETRY<sp />=<sp />10,<sp />RETRY_DELAY_MS<sp />=<sp />1;</highlight></codeline>
<codeline lineno="256"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">do</highlight><highlight class="normal"><sp />{</highlight></codeline>
<codeline lineno="257"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(retry<sp />!=<sp />0)</highlight></codeline>
<codeline lineno="258"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />Cy_SysLib_Delay(RETRY_DELAY_MS);</highlight></codeline>
<codeline lineno="259"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint32_t<sp />savedIntrStatus<sp />=<sp /><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref>();</highlight></codeline>
<codeline lineno="260"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />rslt<sp />=<sp />(<ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref>)Cy_RTC_SetDateAndTime(&amp;newtime);</highlight></codeline>
<codeline lineno="261"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(rslt<sp />==<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>)</highlight></codeline>
<codeline lineno="262"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_rtc_set_century((uint16_t)(time-&gt;tm_year)<sp />-<sp />(uint16_t)(year2digit)<sp />+<sp />(uint16_t)(_CYHAL_RTC_TM_YEAR_BASE));</highlight></codeline>
<codeline lineno="263"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref>(savedIntrStatus);</highlight></codeline>
<codeline lineno="264"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />++retry;</highlight></codeline>
<codeline lineno="265"><highlight class="normal"><sp /><sp /><sp /><sp />}<sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(rslt<sp />==<sp />CY_RTC_INVALID_STATE<sp />&amp;&amp;<sp />retry<sp />&lt;<sp />MAX_RETRY);</highlight></codeline>
<codeline lineno="266"><highlight class="normal" /></codeline>
<codeline lineno="267"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal"><sp />(CY_RTC_BUSY<sp />==<sp />Cy_RTC_GetSyncStatus())<sp />{<sp />}</highlight></codeline>
<codeline lineno="268"><highlight class="normal" /></codeline>
<codeline lineno="269"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(rslt<sp />==<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>)</highlight></codeline>
<codeline lineno="270"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_rtc_set_state(_CYHAL_RTC_STATE_TIME_SET);</highlight></codeline>
<codeline lineno="271"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />rslt;</highlight></codeline>
<codeline lineno="272"><highlight class="normal">}</highlight></codeline>
<codeline lineno="273"><highlight class="normal" /></codeline>
<codeline lineno="274"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga5e6893121f3be9026d5cf4cb10c008bf">cyhal_rtc_set_dst</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__rtc__dst__t">cyhal_rtc_dst_t</ref><sp />*start,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__rtc__dst__t">cyhal_rtc_dst_t</ref><sp />*stop)</highlight></codeline>
<codeline lineno="275"><highlight class="normal">{</highlight></codeline>
<codeline lineno="276"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="277"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />start);</highlight></codeline>
<codeline lineno="278"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />stop);</highlight></codeline>
<codeline lineno="279"><highlight class="normal" /></codeline>
<codeline lineno="280"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_rtc_initialize_dst(start,<sp />&amp;(obj-&gt;dst.startDst));</highlight></codeline>
<codeline lineno="281"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_rtc_initialize_dst(stop,<sp />&amp;(obj-&gt;dst.stopDst));</highlight></codeline>
<codeline lineno="282"><highlight class="normal" /></codeline>
<codeline lineno="283"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_rtc_config_t<sp />dateTime;</highlight></codeline>
<codeline lineno="284"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_GetDateAndTime(&amp;dateTime);</highlight></codeline>
<codeline lineno="285"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp />rslt<sp />=<sp />Cy_RTC_EnableDstTime(&amp;(obj-&gt;dst),<sp />&amp;dateTime);</highlight></codeline>
<codeline lineno="286"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(rslt<sp />==<sp /><ref kindref="member" refid="group__group__result_1gaf58fac450d9fff4472f03ad68f6e546e">CY_RSLT_SUCCESS</ref>)</highlight></codeline>
<codeline lineno="287"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />_cyhal_rtc_dst<sp />=<sp />&amp;(obj-&gt;dst);</highlight></codeline>
<codeline lineno="288"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />rslt;</highlight></codeline>
<codeline lineno="289"><highlight class="normal">}</highlight></codeline>
<codeline lineno="290"><highlight class="normal" /></codeline>
<codeline lineno="291"><highlight class="normal" /><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga3e56df18a9506e3d25050d4dabe7fd4c">cyhal_rtc_is_dst</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj)</highlight></codeline>
<codeline lineno="292"><highlight class="normal">{</highlight></codeline>
<codeline lineno="293"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="294"><highlight class="normal" /></codeline>
<codeline lineno="295"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_rtc_config_t<sp />dateTime;</highlight></codeline>
<codeline lineno="296"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_GetDateAndTime(&amp;dateTime);</highlight></codeline>
<codeline lineno="297"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />Cy_RTC_GetDstStatus(&amp;(obj-&gt;dst),<sp />&amp;dateTime);</highlight></codeline>
<codeline lineno="298"><highlight class="normal">}</highlight></codeline>
<codeline lineno="299"><highlight class="normal" /></codeline>
<codeline lineno="300"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga4281bd53cab53fb245a1e98a618e1679">cyhal_rtc_set_alarm</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">struct</highlight><highlight class="normal"><sp />tm<sp />*time,<sp /><ref kindref="compound" refid="structcyhal__alarm__active__t">cyhal_alarm_active_t</ref><sp />active)</highlight></codeline>
<codeline lineno="301"><highlight class="normal">{</highlight></codeline>
<codeline lineno="302"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Note:<sp />the<sp />hardware<sp />does<sp />not<sp />support<sp />year<sp />matching</highlight><highlight class="normal" /></codeline>
<codeline lineno="303"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="304"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="305"><highlight class="normal"><sp /><sp /><sp /><sp />cy_stc_rtc_alarm_t<sp />alarm<sp />=<sp />{</highlight></codeline>
<codeline lineno="306"><highlight class="normal"><sp /><sp /><sp /><sp />.sec<sp />=<sp />(uint32_t)time-&gt;tm_sec,</highlight></codeline>
<codeline lineno="307"><highlight class="normal"><sp /><sp /><sp /><sp />.secEn<sp />=<sp />active.<ref kindref="member" refid="structcyhal__alarm__active__t_1aa36c2142cb8a0dead7b6d40fcd499099">en_sec</ref><sp />?<sp />CY_RTC_ALARM_ENABLE<sp />:<sp />CY_RTC_ALARM_DISABLE,</highlight></codeline>
<codeline lineno="308"><highlight class="normal"><sp /><sp /><sp /><sp />.min<sp />=<sp />(uint32_t)time-&gt;tm_min,</highlight></codeline>
<codeline lineno="309"><highlight class="normal"><sp /><sp /><sp /><sp />.minEn<sp />=<sp />active.<ref kindref="member" refid="structcyhal__alarm__active__t_1a320940624827f9d754184447393a95f0">en_min</ref><sp />?<sp />CY_RTC_ALARM_ENABLE<sp />:<sp />CY_RTC_ALARM_DISABLE,</highlight></codeline>
<codeline lineno="310"><highlight class="normal"><sp /><sp /><sp /><sp />.hour<sp />=<sp />(uint32_t)time-&gt;tm_hour,</highlight></codeline>
<codeline lineno="311"><highlight class="normal"><sp /><sp /><sp /><sp />.hourEn<sp />=<sp />active.<ref kindref="member" refid="structcyhal__alarm__active__t_1a8d9c92fe49428aedd8c78985a41f6967">en_hour</ref><sp />?<sp />CY_RTC_ALARM_ENABLE<sp />:<sp />CY_RTC_ALARM_DISABLE,</highlight></codeline>
<codeline lineno="312"><highlight class="normal"><sp /><sp /><sp /><sp />.dayOfWeek<sp />=<sp />(uint32_t)(time-&gt;tm_wday<sp />+<sp />1),</highlight></codeline>
<codeline lineno="313"><highlight class="normal"><sp /><sp /><sp /><sp />.dayOfWeekEn<sp />=<sp />active.<ref kindref="member" refid="structcyhal__alarm__active__t_1af8fbeff616036b99a30ac05404420cb1">en_day</ref><sp />?<sp />CY_RTC_ALARM_ENABLE<sp />:<sp />CY_RTC_ALARM_DISABLE,</highlight></codeline>
<codeline lineno="314"><highlight class="normal"><sp /><sp /><sp /><sp />.date<sp />=<sp />(uint32_t)time-&gt;tm_mday,</highlight></codeline>
<codeline lineno="315"><highlight class="normal"><sp /><sp /><sp /><sp />.dateEn<sp />=<sp />active.<ref kindref="member" refid="structcyhal__alarm__active__t_1a3f14355696e229e8f2e8a8c03951cb22">en_date</ref><sp />?<sp />CY_RTC_ALARM_ENABLE<sp />:<sp />CY_RTC_ALARM_DISABLE,</highlight></codeline>
<codeline lineno="316"><highlight class="normal"><sp /><sp /><sp /><sp />.month<sp />=<sp />(uint32_t)(time-&gt;tm_mon<sp />+<sp />1),</highlight></codeline>
<codeline lineno="317"><highlight class="normal"><sp /><sp /><sp /><sp />.monthEn<sp />=<sp />active.<ref kindref="member" refid="structcyhal__alarm__active__t_1aa3904e107ba274b3e28966fa87d175d1">en_month</ref><sp />?<sp />CY_RTC_ALARM_ENABLE<sp />:<sp />CY_RTC_ALARM_DISABLE,</highlight></codeline>
<codeline lineno="318"><highlight class="normal"><sp /><sp /><sp /><sp />.almEn<sp />=<sp />CY_RTC_ALARM_ENABLE</highlight></codeline>
<codeline lineno="319"><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="320"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref>)Cy_RTC_SetAlarmDateAndTime(&amp;alarm,<sp />CY_RTC_ALARM_1);</highlight></codeline>
<codeline lineno="321"><highlight class="normal">}</highlight></codeline>
<codeline lineno="322"><highlight class="normal" /></codeline>
<codeline lineno="323"><highlight class="normal"><ref kindref="member" refid="group__group__result_1gaca79700fcc701534ce61778a9bcf57d1">cy_rslt_t</ref><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga2b3a85af9b9b878e8cae824d5f847b88">cyhal_rtc_set_alarm_by_seconds</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj,<sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />seconds)</highlight></codeline>
<codeline lineno="324"><highlight class="normal">{</highlight></codeline>
<codeline lineno="325"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="326"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp />uint32_t<sp />SECONDS_IN_YEAR<sp />=<sp />365*24*60*60;<sp /></highlight><highlight class="comment">//<sp />31,536,000</highlight><highlight class="normal" /></codeline>
<codeline lineno="327"><highlight class="normal" /></codeline>
<codeline lineno="328"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />Note:<sp />The<sp />hardware<sp />does<sp />not<sp />support<sp />year<sp />matching<sp />so<sp />return<sp />error<sp />if</highlight><highlight class="normal" /></codeline>
<codeline lineno="329"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">//<sp />seconds<sp />is<sp />greater<sp />than<sp />1<sp />year<sp />in<sp />the<sp />future</highlight><highlight class="normal" /></codeline>
<codeline lineno="330"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal">(seconds<sp />&gt;<sp />SECONDS_IN_YEAR)</highlight></codeline>
<codeline lineno="331"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__results__rtc_1ga6c6143b437306d30ee23482cce83d461">CY_RSLT_RTC_BAD_ARGUMENT</ref>;</highlight></codeline>
<codeline lineno="332"><highlight class="normal" /></codeline>
<codeline lineno="333"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">tm<sp />now;</highlight></codeline>
<codeline lineno="334"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />savedIntrStatus<sp />=<sp /><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref>();</highlight></codeline>
<codeline lineno="335"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga5c3f15f870f2ecfb4a8a03a58d1eaa5f">cyhal_rtc_read</ref>(obj,<sp />&amp;now);</highlight></codeline>
<codeline lineno="336"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref>(savedIntrStatus);</highlight></codeline>
<codeline lineno="337"><highlight class="normal" /></codeline>
<codeline lineno="338"><highlight class="normal"><sp /><sp /><sp /><sp />time_t<sp />future_time_t<sp />=<sp />mktime(&amp;now)<sp />+<sp />seconds;</highlight></codeline>
<codeline lineno="339"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">struct<sp /></highlight><highlight class="normal">tm*<sp />future<sp />=<sp />localtime(&amp;future_time_t);</highlight></codeline>
<codeline lineno="340"><highlight class="normal" /></codeline>
<codeline lineno="341"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keyword">static</highlight><highlight class="normal"><sp /></highlight><highlight class="keyword">const</highlight><highlight class="normal"><sp /><ref kindref="compound" refid="structcyhal__alarm__active__t">cyhal_alarm_active_t</ref><sp />active<sp />=<sp />{</highlight></codeline>
<codeline lineno="342"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcyhal__alarm__active__t_1aa36c2142cb8a0dead7b6d40fcd499099">en_sec</ref><sp /><sp /><sp />=<sp />CY_RTC_ALARM_ENABLE,</highlight></codeline>
<codeline lineno="343"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.en_min<sp /><sp /><sp />=<sp />CY_RTC_ALARM_ENABLE,</highlight></codeline>
<codeline lineno="344"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.en_hour<sp /><sp />=<sp />CY_RTC_ALARM_ENABLE,</highlight></codeline>
<codeline lineno="345"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.en_day<sp /><sp /><sp />=<sp />CY_RTC_ALARM_ENABLE,</highlight></codeline>
<codeline lineno="346"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.en_date<sp /><sp />=<sp />CY_RTC_ALARM_ENABLE,</highlight></codeline>
<codeline lineno="347"><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.en_month<sp />=<sp />CY_RTC_ALARM_ENABLE</highlight></codeline>
<codeline lineno="348"><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline lineno="349"><highlight class="normal" /></codeline>
<codeline lineno="350"><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">return</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga4281bd53cab53fb245a1e98a618e1679">cyhal_rtc_set_alarm</ref>(obj,<sp />future,<sp />active);</highlight></codeline>
<codeline lineno="351"><highlight class="normal">}</highlight></codeline>
<codeline lineno="352"><highlight class="normal" /></codeline>
<codeline lineno="353"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga64761d1bb0c23aedc4329b50f8d3361d">cyhal_rtc_register_callback</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__rtc_1ga2fe62b8562ac40925a243c75b0e6810f">cyhal_rtc_event_callback_t</ref><sp />callback,<sp /></highlight><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />*callback_arg)</highlight></codeline>
<codeline lineno="354"><highlight class="normal">{</highlight></codeline>
<codeline lineno="355"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="356"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="357"><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />savedIntrStatus<sp />=<sp /><ref kindref="member" refid="group__group__hal__system_1ga70a306e5108a38aa995c0ab7d0147e43">cyhal_system_critical_section_enter</ref>();</highlight></codeline>
<codeline lineno="358"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_rtc_handler_arg<sp />=<sp />callback_arg;</highlight></codeline>
<codeline lineno="359"><highlight class="normal"><sp /><sp /><sp /><sp />_cyhal_rtc_user_handler<sp />=<sp />callback;</highlight></codeline>
<codeline lineno="360"><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__hal__system_1ga9fe83f08f46b64c956ec7ed3c335f659">cyhal_system_critical_section_exit</ref>(savedIntrStatus);</highlight></codeline>
<codeline lineno="361"><highlight class="normal">}</highlight></codeline>
<codeline lineno="362"><highlight class="normal" /></codeline>
<codeline lineno="363"><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__hal__rtc_1ga92d82cf6e7ca376c5a41004d2d67cd4d">cyhal_rtc_enable_event</ref>(<ref kindref="compound" refid="structcyhal__rtc__t">cyhal_rtc_t</ref><sp />*obj,<sp /><ref kindref="member" refid="group__group__hal__rtc_1ga65837a686b1fab2e3b11e0d3ba1fdafe">cyhal_rtc_event_t</ref><sp />event,<sp />uint8_t<sp />intr_priority,<sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />enable)</highlight></codeline>
<codeline lineno="364"><highlight class="normal">{</highlight></codeline>
<codeline lineno="365"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(obj);</highlight></codeline>
<codeline lineno="366"><highlight class="normal"><sp /><sp /><sp /><sp />CY_UNUSED_PARAMETER(event);</highlight></codeline>
<codeline lineno="367"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(NULL<sp />!=<sp />obj);</highlight></codeline>
<codeline lineno="368"><highlight class="normal"><sp /><sp /><sp /><sp />CY_ASSERT(<ref kindref="member" refid="group__group__hal__rtc_1gga65837a686b1fab2e3b11e0d3ba1fdafea2bf87c0718ced4a1e2528575068bcc37">CYHAL_RTC_ALARM</ref><sp />==<sp />event);</highlight></codeline>
<codeline lineno="369"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_ClearInterrupt(CY_RTC_INTR_ALARM1<sp />|<sp />CY_RTC_INTR_ALARM2);</highlight></codeline>
<codeline lineno="370"><highlight class="normal"><sp /><sp /><sp /><sp />Cy_RTC_SetInterruptMask((enable<sp />?<sp />CY_RTC_INTR_ALARM1<sp />:<sp />0)<sp />|<sp />CY_RTC_INTR_CENTURY);</highlight></codeline>
<codeline lineno="371"><highlight class="normal"><sp /><sp /><sp /><sp />NVIC_SetPriority(srss_interrupt_backup_IRQn,<sp />intr_priority);</highlight></codeline>
<codeline lineno="372"><highlight class="normal">}</highlight></codeline>
<codeline lineno="373"><highlight class="normal" /></codeline>
<codeline lineno="374"><highlight class="normal" /><highlight class="preprocessor">#if<sp />defined(__cplusplus)</highlight><highlight class="normal" /></codeline>
<codeline lineno="375"><highlight class="normal">}</highlight></codeline>
<codeline lineno="376"><highlight class="normal" /><highlight class="preprocessor">#endif</highlight><highlight class="normal" /></codeline>
<codeline lineno="377"><highlight class="normal" /></codeline>
<codeline lineno="378"><highlight class="normal" /><highlight class="preprocessor">#endif<sp /></highlight><highlight class="comment">/*<sp />CY_IP_MXS40SRSS_RTC_INSTANCES<sp />*/</highlight><highlight class="preprocessor" /></codeline>
    </programlisting>
    <location file="output/libs/COMPONENT_DEPRECATED/psoc6hal/COMPONENT_PSOC6HAL/source/cyhal_rtc.c" />
  </compounddef>
</doxygen>